Source-Changes-HG archive

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index][Old Index]

[src/trunk]: src/tests Add tests to ensure that the new asm examples build an...



details:   https://anonhg.NetBSD.org/src/rev/81b1b284c433
branches:  trunk
changeset: 771140:81b1b284c433
user:      jmmv <jmmv%NetBSD.org@localhost>
date:      Sat Nov 12 01:19:25 2011 +0000

description:
Add tests to ensure that the new asm examples build and run, just as the
end-user is supposed to work with them.

diffstat:

 tests/Makefile          |   4 +-
 tests/examples/Makefile |   9 +++++
 tests/examples/t_asm.sh |  74 +++++++++++++++++++++++++++++++++++++++++++++++++
 3 files changed, 85 insertions(+), 2 deletions(-)

diffs (109 lines):

diff -r 5d147c05699c -r 81b1b284c433 tests/Makefile
--- a/tests/Makefile    Sat Nov 12 01:18:40 2011 +0000
+++ b/tests/Makefile    Sat Nov 12 01:19:25 2011 +0000
@@ -1,4 +1,4 @@
-# $NetBSD: Makefile,v 1.33 2011/09/21 02:14:38 mrg Exp $
+# $NetBSD: Makefile,v 1.34 2011/11/12 01:19:25 jmmv Exp $
 
 .include <bsd.own.mk>
 
@@ -7,7 +7,7 @@
 TESTSDIR=      ${TESTSBASE}
 ATFFILE=       yes
 
-SUBDIR=                dev fs games include ipf kernel lib libexec net
+SUBDIR=                dev examples fs games include ipf kernel lib libexec net
 SUBDIR+=       rump sbin sys toolchain usr.bin usr.sbin util
 
 . if ${MKKMOD} != "no"
diff -r 5d147c05699c -r 81b1b284c433 tests/examples/Makefile
--- /dev/null   Thu Jan 01 00:00:00 1970 +0000
+++ b/tests/examples/Makefile   Sat Nov 12 01:19:25 2011 +0000
@@ -0,0 +1,9 @@
+# $NetBSD: Makefile,v 1.1 2011/11/12 01:19:25 jmmv Exp $
+
+.include <bsd.own.mk>
+
+TESTSDIR=      ${TESTSBASE}/examples
+
+TESTS_SH=      t_asm
+
+.include <bsd.test.mk>
diff -r 5d147c05699c -r 81b1b284c433 tests/examples/t_asm.sh
--- /dev/null   Thu Jan 01 00:00:00 1970 +0000
+++ b/tests/examples/t_asm.sh   Sat Nov 12 01:19:25 2011 +0000
@@ -0,0 +1,74 @@
+# $NetBSD: t_asm.sh,v 1.1 2011/11/12 01:19:25 jmmv Exp $
+#
+# Copyright (c) 2011 The NetBSD Foundation, Inc.
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions are
+# met:
+#
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
+# PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
+# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
+# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
+# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+# check_implemented <example_name>
+#
+# Verifies if a particular asm example is implemented for the current
+# platform.  The example_name argument is the name of the subdirectory
+# of the examples/asm/ subtree that includes the code for the example
+# under test.
+#
+# If the example is not implemented, the calling test is skipped.  If the
+# check for implementation fails, the calling test is failed.
+check_implemented() {
+       local name="${1}"; shift
+
+       local implemented=$(cd /usr/share/examples/asm/${name}/ && \
+                           make check-implemented)
+       [ $? -eq 0 ] || atf_fail "Failed to determine if the sample" \
+           "program is supported"
+       [ "${implemented}" = yes ] || atf_skip "Example program not" \
+           "implemented on this platform"
+}
+
+# copy_example <example_name>
+#
+# Copies the example code and supporting Makefiles into the current
+# directory.
+copy_example() {
+       local name="${1}"; shift
+
+       cp /usr/share/examples/asm/${name}/* .
+}
+
+atf_test_case hello
+hello_head() {
+       atf_set "descr" "Builds, runs and validates the 'hello' asm example"
+       atf_set "require.files" "/usr/share/examples/asm/hello/"
+       atf_set "require.progs" "make"
+}
+hello_body() {
+       check_implemented hello
+       copy_example hello
+       atf_check -s exit:0 -o ignore -e ignore make
+       atf_check -s exit:0 -o inline:'Hello, world!\n' -e empty ./hello
+}
+
+atf_init_test_cases() {
+       atf_add_test_case hello
+}



Home | Main Index | Thread Index | Old Index